#include "Wire.h"
#include <Adafruit_GFX.h>
#include <Wire.h>
#include <ETH.h>
#include "SD.h"
#include "RTClib.h"
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define ANALOG_PIN_0 36
#define ETH_PHY_RESET 5

#define ETH_CLK_MODE    ETH_CLOCK_GPIO17_OUT
#define ETH_POWER_PIN   -1
#define ETH_TYPE        ETH_PHY_LAN8720
#define ETH_ADDR        0
#define ETH_MDC_PIN     23
#define ETH_MDIO_PIN    18

#define RXD 4
#define TXD 33
#define FC  2

#define SCK_PIN 14  // Clock
#define MISO_PIN 16 // Master In Slave Out
#define MOSI_PIN 13 // Master Out Slave In
#define CS_PIN -1    // Chip Select

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

RTC_DS3231 rtc; 
char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

int analog_value = 0;

int readSwitch(){
  analog_value = analogRead(ANALOG_PIN_0);

 
  return analog_value
             ; //Read analog
}

static bool eth_connected = false;
static bool loop_executed = false;
  
void setup() {
  
 Serial.begin(115200);
 delay(1000);
 pinMode(FC, OUTPUT); 
 Serial.println("Hello");

 pinMode(ETH_PHY_RESET,OUTPUT);                                    
 RESET_ETH_PHY();  

  delay(1000);
  Serial.println("Hello");

  Serial.println("Checking Ethernet");
  WiFi.onEvent(WiFiEvent);                                          
  ETH.begin(ETH_ADDR, ETH_POWER_PIN, ETH_MDC_PIN, ETH_MDIO_PIN, ETH_TYPE, ETH_CLK_MODE);        

  delay(5000);
  Serial.print("ETH MAC: ");
  Serial.print(ETH.macAddress());
  
 digitalWrite(FC, HIGH);

  pinMode(CS_PIN, OUTPUT); //CS PIN SD
 digitalWrite(CS_PIN, HIGH);

 Serial1.begin(9600, SERIAL_8N1,RXD,TXD);
 
 Wire.begin(32,15);

  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }
  display.display();
  
  RTC_Check();
  
  SPI.begin(SCK_PIN, MISO_PIN, MOSI_PIN);
  SD_CHECK();
 
 adcAttachPin(36);
 digitalWrite(FC, HIGH);   // RS-485 
}

void loop() {
  
if (!loop_executed) {
    Serial.print("Temperature ");
    Serial.println();
    testClient("google.com", 80);
    Serial.print(ETH.localIP());
    loop_executed = true; // Set the flag to true so the loop only executes once
  }
  Serial.println(""); 
  Serial.print("Push button  ");Serial.println(readSwitch());
  Serial.println(""); 
  
  digitalWrite(FC, HIGH);                    // Make FLOW CONTROL pin HIGH
  delay(500);
  Serial1.println(F("RS485 01 SUCCESS"));    // Send RS485 SUCCESS serially
  delay(500);                                // Wait for transmission of data
  digitalWrite(FC, LOW) ;                    // Receiving mode ON

                                             // Serial1.flush() ;
  delay(1000);     
  
  while (Serial1.available()) {  // Check if data is available
    char c = Serial1.read();     // Read data from RS485
    Serial.write(c);             // Print data on serial monitor
  }
}

void RESET_ETH_PHY(){
  digitalWrite(ETH_PHY_RESET,LOW);
  delay(100);
  digitalWrite(ETH_PHY_RESET,HIGH);
}

void WiFiEvent(WiFiEvent_t event) {
  switch (event) {
    case SYSTEM_EVENT_ETH_START:
      Serial.println("ETH Started");
      ETH.setHostname("esp32-ethernet");
      break;
    case SYSTEM_EVENT_ETH_CONNECTED:
      Serial.println("ETH Connected");
      break;
    case SYSTEM_EVENT_ETH_GOT_IP:
      Serial.print("ETH MAC: ");
      Serial.print(ETH.macAddress());
      Serial.print(", IPv4: ");
      Serial.print(ETH.localIP());
      if (ETH.fullDuplex()) {
        Serial.print(", FULL_DUPLEX");
      }
      Serial.print(", ");
      Serial.print(ETH.linkSpeed());
      Serial.println("Mbps");
      eth_connected = true;
      break;
    case SYSTEM_EVENT_ETH_DISCONNECTED:
      Serial.println("ETH Disconnected");
      eth_connected = false;
      break;
    case SYSTEM_EVENT_ETH_STOP:
      Serial.println("ETH Stopped");
      eth_connected = false;
      break;
    default:
      break;
  }
}

void testClient(const char * host, uint16_t port) {
  Serial.print("\nconnecting to ");
  Serial.println(host);

  WiFiClient client;
  if (!client.connect(host, port)) {
    Serial.println("connection failed");
    return;
  }
  client.printf("GET / HTTP/1.1\r\nHost: %s\r\n\r\n", host);
  while (client.connected() && !client.available());
  while (client.available()) {
    Serial.write(client.read());
  }

  Serial.println("closing connection\n");
  client.stop();
}

void SD_CHECK(){
  uint8_t cardType = SD.cardType();
  
    if(SD.begin(12))
 {
  Serial.println("Card Mount: success");
  Serial.print("Card Type: ");

    if(cardType == CARD_MMC){
        Serial.println("MMC");
    } else if(cardType == CARD_SD){
        Serial.println("SDSC");
    } else if(cardType == CARD_SDHC){
        Serial.println("SDHC");
    } else {
        Serial.println("Unknown");
    }

  int cardSize = SD.cardSize() / (1024 * 1024);
  Serial.printf("Card Size: %lluMB\n", cardSize);

  }

  if(!SD.begin(12))
  {
  Serial.println("NO SD card");            
  }

}

void displayTime(void) {
  DateTime now = rtc.now();
     
  Serial.print(now.year(), DEC);
  Serial.print('/');
  Serial.print(now.month(), DEC);
  Serial.print('/');
  Serial.print(now.day(), DEC);
  Serial.print(" ");
  Serial.print(daysOfTheWeek[now.dayOfTheWeek()]);

  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  Serial.print(now.second(), DEC);
  Serial.println();
  delay(1000);

}

void RTC_Check(){
  if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
  }
 else{
 if (rtc.lostPower()) {
  
    Serial.println("RTC lost power, lets set the time!");
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    
  }

   
  int a=1;
  while(a<6)
  {
  displayTime();   // printing time function for oled
  a=a+1;
  }
 }
}
